From 1775d3b30581c4c569cc1f85381abac32c26f8c1 Mon Sep 17 00:00:00 2001
From: Andrew Dunstan <andrew@dunslane.net>
Date: Thu, 16 Sep 2021 10:28:55 -0400
Subject: [PATCH 1/4] SQL/JSON functions

Common SQL/JSON clauses
SQL/JSON constructors
IS JSON predicate
SQL/JSON query functions
SQL/JSON functions for json type
GUC sql_json
---
 doc/src/sgml/config.sgml                      |   19 +
 doc/src/sgml/func.sgml                        | 2027 +++++++++++++++++
 doc/src/sgml/keywords/sql2016-02-reserved.txt |    3 +
 src/backend/executor/execExpr.c               |  349 ++-
 src/backend/executor/execExprInterp.c         |  726 ++++++
 src/backend/jit/llvm/llvmjit_expr.c           |   18 +
 src/backend/jit/llvm/llvmjit_types.c          |    3 +
 src/backend/nodes/copyfuncs.c                 |  433 ++++
 src/backend/nodes/equalfuncs.c                |  293 +++
 src/backend/nodes/makefuncs.c                 |  103 +
 src/backend/nodes/nodeFuncs.c                 |  427 ++++
 src/backend/nodes/outfuncs.c                  |  141 ++
 src/backend/nodes/readfuncs.c                 |  177 ++
 src/backend/optimizer/path/costsize.c         |    3 +-
 src/backend/optimizer/util/clauses.c          |   78 +
 src/backend/parser/gram.y                     |  767 ++++++-
 src/backend/parser/parse_collate.c            |    4 +
 src/backend/parser/parse_expr.c               | 1471 ++++++++++++
 src/backend/parser/parse_target.c             |   37 +
 src/backend/parser/parser.c                   |   16 +
 src/backend/utils/adt/format_type.c           |    9 +
 src/backend/utils/adt/formatting.c            |   45 +-
 src/backend/utils/adt/json.c                  |  572 ++++-
 src/backend/utils/adt/jsonb.c                 |  352 ++-
 src/backend/utils/adt/jsonb_util.c            |   24 +-
 src/backend/utils/adt/jsonfuncs.c             |   70 +-
 src/backend/utils/adt/jsonpath.c              |  257 +++
 src/backend/utils/adt/jsonpath_exec.c         |  350 ++-
 src/backend/utils/adt/ruleutils.c             |  437 +++-
 src/backend/utils/misc/guc.c                  |   19 +
 src/backend/utils/misc/postgresql.conf.sample |    1 +
 src/backend/utils/misc/queryjumble.c          |   69 +
 src/include/catalog/pg_aggregate.dat          |   22 +
 src/include/catalog/pg_proc.dat               |   70 +
 src/include/executor/execExpr.h               |   81 +
 src/include/executor/executor.h               |    2 +
 src/include/nodes/makefuncs.h                 |   10 +
 src/include/nodes/nodes.h                     |   24 +
 src/include/nodes/parsenodes.h                |  203 ++
 src/include/nodes/primnodes.h                 |  222 ++
 src/include/parser/kwlist.h                   |   22 +
 src/include/utils/formatting.h                |    4 +
 src/include/utils/json.h                      |   26 +
 src/include/utils/jsonb.h                     |   47 +
 src/include/utils/jsonfuncs.h                 |    7 +
 src/include/utils/jsonpath.h                  |   33 +
 src/interfaces/ecpg/preproc/parse.pl          |    2 +
 src/interfaces/ecpg/preproc/parser.c          |   14 +
 src/test/regress/expected/json_sqljson.out    |   15 +
 src/test/regress/expected/jsonb.out           |  130 ++
 src/test/regress/expected/jsonb_sqljson.out   | 1018 +++++++++
 src/test/regress/expected/opr_sanity.out      |    6 +-
 src/test/regress/expected/sqljson.out         | 1352 +++++++++++
 src/test/regress/parallel_schedule            |    2 +-
 src/test/regress/sql/json_sqljson.sql         |   11 +
 src/test/regress/sql/jsonb.sql                |   38 +
 src/test/regress/sql/jsonb_sqljson.sql        |  317 +++
 src/test/regress/sql/opr_sanity.sql           |    6 +-
 src/test/regress/sql/sqljson.sql              |  467 ++++
 59 files changed, 13151 insertions(+), 300 deletions(-)
 create mode 100644 src/test/regress/expected/json_sqljson.out
 create mode 100644 src/test/regress/expected/jsonb_sqljson.out
 create mode 100644 src/test/regress/expected/sqljson.out
 create mode 100644 src/test/regress/sql/json_sqljson.sql
 create mode 100644 src/test/regress/sql/jsonb_sqljson.sql
 create mode 100644 src/test/regress/sql/sqljson.sql

diff --git a/doc/src/sgml/config.sgml b/doc/src/sgml/config.sgml
index ef0e2a7746..1b9a552ec8 100644
--- a/doc/src/sgml/config.sgml
+++ b/doc/src/sgml/config.sgml
@@ -9500,6 +9500,25 @@ dynamic_library_path = 'C:\tools\postgresql;H:\my_project\lib;$libdir'
       </listitem>
      </varlistentry>
 
+     <varlistentry id="guc-sql-json" xreflabel="sql_json">
+      <term><varname>sql_json</varname> (<type>enum</type>)
+      <indexterm><primary>json</primary></indexterm>
+      <indexterm><primary>jsonb</primary></indexterm>
+      <indexterm>
+       <primary><varname>sql_json</varname> configuration parameter</primary>
+      </indexterm>
+      </term>
+      <listitem>
+       <para>
+         Valid values are <literal>json</literal> and <literal>jsonb</literal>.
+         Specifies what <productname>PostgreSQL</productname> type is used
+         as an implementation of SQL type <type>JSON</type>.
+         When <varname>sql_json</varname> is set to <literal>jsonb</literal>,
+         <productname>PostgreSQL</productname> type <type>json</type> can be
+         accessed using explicit qualification <type>pg_catalog.json</type>.
+       </para>
+      </listitem>
+     </varlistentry>
      </variablelist>
     </sect2>
    </sect1>
